"""generate accessible pygments themes for testing"""

from pathlib import Path


HERE = Path(__file__).parent

themes = """a11y-dark
a11y-light
a11y-high-contrast-dark
a11y-high-contrast-light
github-light
github-dark
github-light-colorblind
github-dark-colorblind
github-light-high-contrast
github-dark-high-contrast
gotthard-dark
gotthard-light
blinds-light
blinds-dark""".split()


# exclude greative, pitaya-smoothie because we are using light/dark theme pairs


def get_pygments(target, theme):
    import pygments.formatters

    target.write_text(
        f"""/** accessible pygments {theme} generated by {__name__}**/\n"""
        + pygments.formatters.get_formatter_by_name("html", style=theme).get_style_defs()
    )


for theme in themes:
    get_pygments(target := HERE / f"{theme}.css", theme)
    print(f"wrote {theme} theme to {target.relative_to(HERE.parent.parent.parent)}")
